#ifndef matrix34
#define matrix34

#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct fmatrix{
/*	float	xu,xv,xw,xx;
	float	yu,yv,yw,yy;
	float	zu,zv,zw,zz;
*/
  float	xu,yu,zu,dummy1;
  float	xv,yv,zv,dummy2;
  float	xw,yw,zw,dummy3;
  float	xx,yy,zz,dummy4;
  
} fmatrix __attribute__((aligned(16)));

void setmatrixcolumnsf(fmatrix *m, fvec *u, fvec *v, fvec *w, fvec *p);
void transposematrixf(fmatrix *m);
void screenmatrixf(fmatrix *m, float width, float height, float offsetx, float offsety);
void resetmatrixf(fmatrix *m);
void scalematrixf(fmatrix *m, float x, float y, float z);
void rotatematrixzf(fmatrix *m, float v);
void rotatematrixyf(fmatrix *m, float v);
void rotatematrixxf(fmatrix *m, float v);
void movematrixf(fmatrix *m, float x, float y, float z);
void fmovematrixf(fmatrix *m, float x, float y, float z);
void frotatematrixzf(fmatrix *m, float v);
void frotatematrixyf(fmatrix *m, float v);
void frotatematrixxf(fmatrix *m, float v);
void frotatematrixzf2(fmatrix *m, float c, float s);
void frotatematrixyf2(fmatrix *m, float c, float s);
void frotatematrixxf2(fmatrix *m, float c, float s);
void fscalematrixf(fmatrix *m, float x, float y, float z);
void fmulmatrixf(fmatrix *m, fmatrix *n);
void mulmatrixf(fmatrix *m, fmatrix *n);
void rotatematrixf(fmatrix *m, float x, float y, float z, float v);
void skewmatrixxtozf(fmatrix *m, float s);
void skewmatrixytozf(fmatrix *m, float s);
void fskewmatrixxtozf(fmatrix *m, float s);
void fskewmatrixytozf(fmatrix *m, float s);
void transformf(fmatrix *m, fvec *s, fvec *d, int n);
void transformf2(fmatrix *m, fvec *s, fvec *d, int n);
void printmatrixf(fmatrix *m);
void printhexvector(ivec v);
void printvector(fvec v);
void lookatmatrixf(fmatrix *m, fvec direction, fvec up);

#ifdef __cplusplus
}
#endif

#endif
