#include "string.h"

char toupper(char c)
{
  return c&(255-32);
}


unsigned int strlen(char *s)
{
  int r=0;
	
  while(s[r]!=0){r++;}
  
  return r;
}


unsigned int strcmp(const char *s, const char *t)
{
//	memcpy(1,2,3);

  while(*s==*t){if((*s==0)||(*t==0))break;t++;s++;}
  
  if(*s==*t)return 0;
  if(*s>*t)return 1;
  return (unsigned int)-1;
}


void *memcpy(void *s, const void *ct, unsigned int n)
{
  int t;
  
  for(t=0;t<n;t++)((char*)s)[t]=((char*)ct)[t];
  
  return s;
}


char *strcpy(char *s, const char *ct)
{
  int t=0;
  
  do
    {
      ((char*)s)[t]=((char*)ct)[t];
      t++;
    }
  while(((char*)ct)[t-1]);

  return s;
}


char *strncpy(char *s, const char *ct, int n)
{
  int t,tt=0;
  
  for(t=0;t<n;t++)
    {
      ((char*)s)[t]=((char*)ct)[tt];
      if(((char*)ct)[tt])tt++;
    }
  
  return s;
}

//extern __ptr_t memcpy __P ((__ptr_t __dest, __const __ptr_t __src,
//			    size_t __n));

//extern __ptr_t memset __P ((__ptr_t __s, int __c, size_t __n));

static void reverse(char *s)
{
  int t;
  int l=strlen(s);
  
  for(t=0;t<l/2;t++)
    {
      char temp=s[t];
      s[t]=s[l-t-1];
      s[l-t-1]=temp;
    }
}

static int mindigits=1;
static int signon=1;
void string_setmindigits(int n)
{
  mindigits=n;
}

void string_setsign(int n)
{
  signon=n;
}

void itob(int n, char *s, char *b)
{
  int base=strlen(b);
  //	int base=10;
  int i=0;
  int sign=1;
  int min=4;
  unsigned int N;
  
  if(signon&&(n<0))
    {
      N=-n;
      sign=-1;
    }
  else N=n;
  
  while((N>0)||(i<mindigits))
    {
      s[i++]=b[N%base];
      N/=base;
    }
  
  if(sign==-1)
    {
      s[i++]='-';
    }
  s[i++]=0;
  
  reverse(s);
}


void itog(int n, char *s)
{
  itob(n,s,"0123456789ABCDEF");
}


void itoa(int n, char *s)
{
  itob(n,s,"0123456789");
}


void ito2(int n, char *s)
{
  itob(n,s,"01");
}


void *memset(char *s, int c, unsigned int n)
{
  int t;
  
  for(t=0;t<n;t++)s[t]=c;
  
  return s;
}


void abort()
{
  while(1);
}


void free(char *a)
{
}

